import * as R from 'ramda';
import fetch from 'node-fetch';

// import { OBJ } from './utils';

export const lastArg = R.pipe(Array.of, R.last);

export const defaultEnv = {
  // '>': (a, b) => a > b,
  // '<=': (a, b) => a <= b,
  // '>=': (a, b) => a >= b,
  // '==': (a, b) => Object.is(a, b),
  // '!=': (a, b) => !Object.is(a, b),
  // '===': (a, b) => a === b,
  // '!==': (a, b) => a !== b,
  // get,
  undefined,
  Array,
  Object,
  String,
  Number,
  Promise,
  newPromise: (...args) => new Promise(...args),
  Date,
  newDate: (...args) => new Date(...args),
  Math,
  parseInt,
  parseFloat,
  Set,
  Map,
  newSet: (...args) => new Set(...args),
  newMap: (...args) => new Map(...args),
  RegExp,
  fetch,
};

export const envPlugin = () => ({
  staticEnv: {
    console,
    lastArg,
    ',': lastArg,
    of: Array.of,
    void: () => undefined,
    // noop: () => undefined,
  },
  onLeave: ({ state, current, envHas, getFromEnv }) => {
    if (state !== 'untouched') return undefined;
    if (R.is(String, current) && envHas(current)) {
      // return envHas(current) ? getFromEnv(current) : undefined;
      // console.log('ENV:', current, getFromEnv(current));
      return { type: 'REPLACE', current: getFromEnv(current) };
    }
    return undefined;
  },
});
