import * as R from 'ramda';
import { bi } from 'tri-fp';

// import { OBJ } from './utils';

// const unProcessedTypes = ['Boolean', 'Number', 'Null', 'Undefined', 'Function', 'RegExp'];
// const isUnProcessedType = R.pipe(R.type, R.includes(R.__, unProcessedTypes));

const shouldEvaluateString = R.both(R.startsWith('`'), R.endsWith('`'));
const extractStr = R.slice(1, -1);

export const evaluatePlugin = () => ({
  onLeave: ({ state, current }) => {
    if (state !== 'untouched') return undefined;
    if (R.is(String, current)) {
      const isStrConst = shouldEvaluateString(current);
      return isStrConst
        ? {
            type: 'REPLACE',
            current: extractStr(current),
          }
        : undefined;
      // return { type: 'REPLACE', current: envHas(current) ? getFromEnv(current) : undefined };
    }
    if (Array.isArray(current)) {
      const [fn, ...args] = current;
      // console.log('Evaluate Array:', fn, typeof fn);
      if (!(typeof fn === 'function'))
        return { type: 'ERROR', error: Error(`Not a function: ${fn}`) };
      const [error, result] = bi(fn)(...args);
      if (error) return { type: 'ERROR', error };
      return { type: 'REPLACE', current: result };
    }
    return undefined;
  },
});
